#!/bin/ksh
# Phase 2 of program delivery  update: do update.
# Copyright (c) 1997 Sun Microsystems, Inc.
# @(#)progupdate2.cgi	1.4 97/07/24

BASE=${0%/*}

print "Content-type: text/html"
print
read input
oldIFS=$IFS
IFS='&'
set -- $input
IFS=$oldIFS
while [ "$1" ]
do
	eval "${1%%=*}=\$(${BASE}/urldecode -- '${1#*=}')"
	shift
done

. ${BASE}/dirupdate.cgi

warning=""
options=""
delivery=`echo ${delivery} | sed s/
//g`
print ${Add} > /tmp/foo
if [ ! -z ${Add} ]
then
 count=0
 for i in ${delivery}
 do
  options="${options} <OPTION>$i"
  count=count+1
 done

 if [ ! -z ${newaddress} ]
 then
    valid=`${HTMLBASE}/../imta/lib/test test -rewrite \
        "${newaddress}" | egrep "Address list error|Too many parameters" 2>/dev/null`
    containsCR=`echo ${newaddress} | awk '$0 ~/
/ {print "true"}'`
    if [ -z "$valid" -a -z "$containsCR" ];
    then
      options="${options} <OPTION> ${newaddress}"
      delivery="${delivery} ${newaddress}"
      warning="<p><b><font color="#ff0000">${newaddress} "`gettext "added \
          to the forwarding list,"`
      if [ ${forwardtype} = "local" ]
      then
         warning="$warning"`gettext " choose <I>Deliver to mailbox and forward \
	     </I> or <I>Forward only</I> and"`
         warning="$warning"`gettext " press <I>Apply</I> to make the change \
	     effective"`"</font></b><BR><HR>"
      else
         warning="$warning"`gettext " press <I>Apply</I> to make the change \
	     effective"`"</font></b><BR><HR>"
      fi
    else
     warning="<p><b><font color="#ff0000">"`gettext "WARNING: Illegal address, \
	 try again!"`"</font></b><BR><HR>"
     if [ $count = 0 ]
     then
       options="<OPTION>"`gettext "None"`
     fi
    fi
  else
    warning="<p><b><font color="#ff0000">"`gettext "WARNING: Enter an address \
	and try again!"`"</font></b><BR><HR>"
    if [ $count = 0 ]
    then
     options="<OPTION>"`gettext "None"`
    fi
 fi
fi

if [ ! -z ${Delete} ]
then
 count=0 
 if [ -z ${address} ]
 then
   for i in ${delivery}
   do
       count=count+1
       options="${options} <OPTION>$i"
   done
   if [ $count = 0 ]
   then
      options="<OPTION>"`gettext "None"`
   fi
   warning="<p><b><font color="#ff0000">"`gettext "WARNING: Please choose an \
       address to delete!!"`"</font></b><BR><HR>"
 else
   newdelivery=""  
   for i in ${delivery}
   do
     if [ $i != ${address} ]
     then
       count=count+1
       options="${options} <OPTION>$i"
       newdelivery="${newdelivery} ${i}"
     fi
   done
   if [ $count = 0 ]
   then
      options="<OPTION>"`gettext "None"`
   fi
   warning="<p><b><font color="#ff0000">${address} "`gettext "deleted from \
       the forwarding list,"`
   warning="$warning"`gettext " press <I>Apply</I> to make the change \
       effective"`"</font></b><BR><HR>"
   delivery=${newdelivery}
   
 fi   
fi

if [[ ! -z ${Add} || ! -z ${Delete} ]]
then
 
  local=NONCHECKED
  forward=NONCHECKED
  forward_local=NONCHECKED
  if [ ${forwardtype} = "local" ]
  then
     local=CHECKED
  elif [ ${forwardtype} = "forward" ]
  then
     forward=CHECKED
  else
     forward_local=CHECKED
  fi

  exec < ${HTMLBASE}/${locale}/forwupdate2.html

 while read -r
 do
        case $REPLY in
                %%uid) print \""$uid"\" ;;
                %%dn) print \""$DN"\" ;;
                %%oldpw) print \""$oldpw"\" ;;
                %%locale) print \""$locale"\" ;;
                %%forward) print "$forward" ;;
                %%forward_local) print "$forward_local" ;;
                %%local) print "$local" ;;
                %%options) print "$options" ;;
                %%delivery) print \""$delivery"\" ;;
                %%warning) print "$warning";;
                *) print "$REPLY" ;;
        esac
 done
fi

if [ ! -z ${Apply} ]
then
  if [ ${forwardtype} = "local" ]
  then
     setlocal "$uid" "$oldpw" "$delivery"
     rc=$?
  elif [ ${forwardtype} = "forward" ]
  then
     setforward "$uid" "$oldpw" "$delivery" 
     rc=$?
  else
     setforwardlocal "$uid" "$oldpw" "$delivery"
     rc=$?
  fi
   
  if ((rc == 0))
  then
	cat ${HTMLBASE}/${locale}/forw_ok.html
  else
        warning="<p><b><font color="#ff0000">"`gettext "Changes not applied. "`
        warning="$warning"`gettext "Either the password is wrong or there \
	    are duplicate entries in the address list"`"</font></b><BR><HR>"
	local=NONCHECKED
	forward=NONCHECKED
	forward_local=NONCHECKED
	if [ ${forwardtype} = "local" ]
	then
	  local=CHECKED
	elif [ ${forwardtype} = "forward" ]
	then
	  forward=CHECKED
	else
	  forward_local=CHECKED
	fi
	for i in ${delivery}
	do
	    count=count+1
	    options="${options} <OPTION>$i"
        done
	if [ $count = 0 ]
	then
	   options="<OPTION>"`gettext "None"`
	fi
	exec < ${HTMLBASE}/${locale}/forwupdate2.html

	while read -r
	do
	  case $REPLY in
                %%uid) print \""$uid"\" ;;
                %%dn) print \""$DN"\" ;;
                %%oldpw) print \""$oldpw"\" ;;
                %%locale) print \""$locale"\" ;;
                %%forward) print "$forward" ;;
                %%forward_local) print "$forward_local" ;;
                %%local) print "$local" ;;
                %%options) print "$options" ;;
                %%delivery) print \""$delivery"\" ;;
                %%warning) print "$warning";;
                *) print "$REPLY" ;;
	  esac
	done
  fi

fi
exit 0
